import java.math.BigInteger;
import java.util.Map;

public class Power extends BinaryOperator {
	
	private final BigInteger two = new BigInteger("2");
	
  public Power (ExpressionTree left, ExpressionTree right)
  {super(left,right);}
  
  public BigInteger power(BigInteger x, BigInteger y) {
  	if (y.equals(BigInteger.ZERO))
  		return BigInteger.ONE;
  	else {
  		BigInteger part = power(x,y.divide(two));
  		if (y.remainder(two).equals(BigInteger.ONE))
  			return x.multiply(part).multiply(part);
  		else
  			return part.multiply(part);
  	}
  }
	public BigInteger evaluate(Map variables)
	{return power(getLeft().evaluate(variables), getRight().evaluate(variables));}
	
	public String getOpSymbol()
	{return "^";}
}